Index: /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/ICE/icedyn_rhg_eap.F90
===================================================================
--- /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/ICE/icedyn_rhg_eap.F90	(revision 14199)
+++ /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/ICE/icedyn_rhg_eap.F90	(revision 14200)
@@ -16,5 +16,5 @@
    !!                                           CICE code (Tsamados, Heorton)
    !!----------------------------------------------------------------------
-#if defined key_si3 && ! defined key_agrif
+#if defined key_si3
    !!----------------------------------------------------------------------
    !!   'key_si3'                                       SI3 sea-ice model
@@ -66,5 +66,6 @@
    INTEGER ::   ncvgid   ! netcdf file id
    INTEGER ::   nvarid   ! netcdf variable id
-   REAL(wp), ALLOCATABLE, DIMENSION(:,:) ::   zmsk00, zmsk15
+   REAL(wp), ALLOCATABLE, DIMENSION(:,:) ::   aimsk00
+   REAL(wp), ALLOCATABLE, DIMENSION(:,:) ::   eap_res  , aimsk15
    !!----------------------------------------------------------------------
    !! NEMO/ICE 4.0 , NEMO Consortium (2018)
@@ -202,10 +203,20 @@
       IF( kt == nit000 .AND. lwp )   WRITE(numout,*) '-- ice_dyn_rhg_eap: EAP sea-ice rheology'
       !
-      ! for diagnostics and convergence tests
-      ALLOCATE( zmsk00(jpi,jpj), zmsk15(jpi,jpj) )
+      IF( kt == nit000 )  THEN 
+         !
+         ! for diagnostics 
+         ALLOCATE( aimsk00(jpi,jpj) )
+         ! for convergence tests
+         IF( nn_rhg_chkcvg > 0 ) ALLOCATE( eap_res(jpi,jpj), aimsk15(jpi,jpj) )
+      ENDIF
+      !
       DO_2D( 1, 1, 1, 1 )
-         zmsk00(ji,jj) = MAX( 0._wp , SIGN( 1._wp , at_i(ji,jj) - epsi06  ) ) ! 1 if ice    , 0 if no ice
-         zmsk15(ji,jj) = MAX( 0._wp , SIGN( 1._wp , at_i(ji,jj) - 0.15_wp ) ) ! 1 if 15% ice, 0 if less
+         aimsk00(ji,jj) = MAX( 0._wp , SIGN( 1._wp , at_i(ji,jj) - epsi06  ) ) ! 1 if ice    , 0 if no ice
       END_2D
+      IF( nn_rhg_chkcvg > 0 ) THEN
+         DO_2D( 1, 1, 1, 1 )
+            aimsk15(ji,jj) = MAX( 0._wp , SIGN( 1._wp , at_i(ji,jj) - 0.15_wp ) ) ! 1 if 15% ice, 0 if less
+         END_2D
+      ENDIF
       !
 !!gm for Clem:  OPTIMIZATION:  I think zfmask can be computed one for all at the initialization....
@@ -349,11 +360,11 @@
             zvV = 0.5_wp * ( vt_i(ji,jj) * e1e2t(ji,jj) + vt_i(ji,jj+1) * e1e2t(ji,jj+1) ) * r1_e1e2v(ji,jj) * vmask(ji,jj,1)
             ! ice-bottom stress at U points
-            zvCr = zaU(ji,jj) * rn_lf_depfra * hu(ji,jj,Kmm)
+            zvCr = zaU(ji,jj) * rn_lf_depfra * hu(ji,jj,Kmm) * ( 1._wp - icb_mask(ji,jj) ) ! if grounded icebergs are read: ocean depth = 0
             ztaux_base(ji,jj) = - rn_lf_bfr * MAX( 0._wp, zvU - zvCr ) * EXP( -rn_crhg * ( 1._wp - zaU(ji,jj) ) )
             ! ice-bottom stress at V points
-            zvCr = zaV(ji,jj) * rn_lf_depfra * hv(ji,jj,Kmm)
+            zvCr = zaV(ji,jj) * rn_lf_depfra * hv(ji,jj,Kmm) * ( 1._wp - icb_mask(ji,jj) ) ! if grounded icebergs are read: ocean depth = 0
             ztauy_base(ji,jj) = - rn_lf_bfr * MAX( 0._wp, zvV - zvCr ) * EXP( -rn_crhg * ( 1._wp - zaV(ji,jj) ) )
             ! ice_bottom stress at T points
-            zvCr = at_i(ji,jj) * rn_lf_depfra * ht(ji,jj)
+            zvCr = at_i(ji,jj) * rn_lf_depfra * ht(ji,jj) * ( 1._wp - icb_mask(ji,jj) )    ! if grounded icebergs are read: ocean depth = 0
             tau_icebfr(ji,jj) = - rn_lf_bfr * MAX( 0._wp, vt_i(ji,jj) - zvCr ) * EXP( -rn_crhg * ( 1._wp - at_i(ji,jj) ) )
          END_2D
@@ -749,5 +760,5 @@
 
          ! convergence test
-         IF( nn_rhg_chkcvg == 2 )   CALL rhg_cvg( kt, jter, nn_nevp, u_ice, v_ice, zu_ice, zv_ice )
+         IF( nn_rhg_chkcvg == 2 )   CALL rhg_cvg_eap( kt, jter, nn_nevp, u_ice, v_ice, zu_ice, zv_ice )
          !
          !                                                ! ==================== !
@@ -819,17 +830,17 @@
             &                                  ztauy_ai, 'V', -1.0_wp, ztaux_bi, 'U', -1.0_wp, ztauy_bi, 'V', -1.0_wp )
          !
-         CALL iom_put( 'utau_oi' , ztaux_oi * zmsk00 )
-         CALL iom_put( 'vtau_oi' , ztauy_oi * zmsk00 )
-         CALL iom_put( 'utau_ai' , ztaux_ai * zmsk00 )
-         CALL iom_put( 'vtau_ai' , ztauy_ai * zmsk00 )
-         CALL iom_put( 'utau_bi' , ztaux_bi * zmsk00 )
-         CALL iom_put( 'vtau_bi' , ztauy_bi * zmsk00 )
+         CALL iom_put( 'utau_oi' , ztaux_oi * aimsk00 )
+         CALL iom_put( 'vtau_oi' , ztauy_oi * aimsk00 )
+         CALL iom_put( 'utau_ai' , ztaux_ai * aimsk00 )
+         CALL iom_put( 'vtau_ai' , ztauy_ai * aimsk00 )
+         CALL iom_put( 'utau_bi' , ztaux_bi * aimsk00 )
+         CALL iom_put( 'vtau_bi' , ztauy_bi * aimsk00 )
       ENDIF
 
       ! --- divergence, shear and strength --- !
-      IF( iom_use('icediv') )   CALL iom_put( 'icediv' , pdivu_i  * zmsk00 )   ! divergence
-      IF( iom_use('iceshe') )   CALL iom_put( 'iceshe' , pshear_i * zmsk00 )   ! shear
-      IF( iom_use('icedlt') )   CALL iom_put( 'icedlt' , pdelta_i * zmsk00 )   ! delta
-      IF( iom_use('icestr') )   CALL iom_put( 'icestr' , strength * zmsk00 )   ! strength
+      IF( iom_use('icediv') )   CALL iom_put( 'icediv' , pdivu_i  * aimsk00 )   ! divergence
+      IF( iom_use('iceshe') )   CALL iom_put( 'iceshe' , pshear_i * aimsk00 )   ! shear
+      IF( iom_use('icedlt') )   CALL iom_put( 'icedlt' , pdelta_i * aimsk00 )   ! delta
+      IF( iom_use('icestr') )   CALL iom_put( 'icestr' , strength * aimsk00 )   ! strength
 
       ! --- Stress tensor invariants (SIMIP diags) --- !
@@ -856,6 +867,6 @@
          !
          ! Stress tensor invariants (normal and shear stress N/m) - SIMIP diags - definitions following Coon (1974) and Feltham (2008)
-         IF( iom_use('normstr') )   CALL iom_put( 'normstr', zsig_I (:,:) * zmsk00(:,:) ) ! Normal stress
-         IF( iom_use('sheastr') )   CALL iom_put( 'sheastr', zsig_II(:,:) * zmsk00(:,:) ) ! Maximum shear stress
+         IF( iom_use('normstr') )   CALL iom_put( 'normstr', zsig_I (:,:) * aimsk00(:,:) ) ! Normal stress
+         IF( iom_use('sheastr') )   CALL iom_put( 'sheastr', zsig_II(:,:) * aimsk00(:,:) ) ! Maximum shear stress
 
          DEALLOCATE ( zsig_I, zsig_II )
@@ -903,7 +914,7 @@
          CALL lbc_lnk_multi( 'icedyn_rhg_eap', zyield11, 'T', 1.0_wp, zyield22, 'T', 1.0_wp, zyield12, 'T', 1.0_wp )
 
-         CALL iom_put( 'yield11', zyield11 * zmsk00 )
-         CALL iom_put( 'yield22', zyield22 * zmsk00 )
-         CALL iom_put( 'yield12', zyield12 * zmsk00 )
+         CALL iom_put( 'yield11', zyield11 * aimsk00 )
+         CALL iom_put( 'yield22', zyield22 * aimsk00 )
+         CALL iom_put( 'yield12', zyield12 * aimsk00 )
       ENDIF
 
@@ -911,5 +922,5 @@
       IF( iom_use('aniso') ) THEN
          CALL lbc_lnk( 'icedyn_rhg_eap', paniso_11, 'T', 1.0_wp )
-         CALL iom_put( 'aniso' , paniso_11 * zmsk00 )
+         CALL iom_put( 'aniso' , paniso_11 * aimsk00 )
       ENDIF
 
@@ -922,10 +933,10 @@
             &                                    zfU, 'U', -1.0_wp,   zfV, 'V', -1.0_wp )
 
-         CALL iom_put( 'dssh_dx' , zspgU * zmsk00 )   ! Sea-surface tilt term in force balance (x)
-         CALL iom_put( 'dssh_dy' , zspgV * zmsk00 )   ! Sea-surface tilt term in force balance (y)
-         CALL iom_put( 'corstrx' , zCorU * zmsk00 )   ! Coriolis force term in force balance (x)
-         CALL iom_put( 'corstry' , zCorV * zmsk00 )   ! Coriolis force term in force balance (y)
-         CALL iom_put( 'intstrx' , zfU   * zmsk00 )   ! Internal force term in force balance (x)
-         CALL iom_put( 'intstry' , zfV   * zmsk00 )   ! Internal force term in force balance (y)
+         CALL iom_put( 'dssh_dx' , zspgU * aimsk00 )   ! Sea-surface tilt term in force balance (x)
+         CALL iom_put( 'dssh_dy' , zspgV * aimsk00 )   ! Sea-surface tilt term in force balance (y)
+         CALL iom_put( 'corstrx' , zCorU * aimsk00 )   ! Coriolis force term in force balance (x)
+         CALL iom_put( 'corstry' , zCorV * aimsk00 )   ! Coriolis force term in force balance (y)
+         CALL iom_put( 'intstrx' , zfU   * aimsk00 )   ! Internal force term in force balance (x)
+         CALL iom_put( 'intstry' , zfV   * aimsk00 )   ! Internal force term in force balance (y)
       ENDIF
 
@@ -938,6 +949,6 @@
          DO_2D( 0, 0, 0, 0 )
             ! 2D ice mass, snow mass, area transport arrays (X, Y)
-            zfac_x = 0.5 * u_ice(ji,jj) * e2u(ji,jj) * zmsk00(ji,jj)
-            zfac_y = 0.5 * v_ice(ji,jj) * e1v(ji,jj) * zmsk00(ji,jj)
+            zfac_x = 0.5 * u_ice(ji,jj) * e2u(ji,jj) * aimsk00(ji,jj)
+            zfac_y = 0.5 * v_ice(ji,jj) * e1v(ji,jj) * aimsk00(ji,jj)
 
             zdiag_xmtrp_ice(ji,jj) = rhoi * zfac_x * ( vt_i(ji+1,jj) + vt_i(ji,jj) ) ! ice mass transport, X-component
@@ -973,20 +984,18 @@
             IF( ln_aEVP ) THEN   ! output: beta * ( u(t=nn_nevp) - u(t=nn_nevp-1) )
                CALL iom_put( 'uice_cvg', MAX( ABS( u_ice(:,:) - zu_ice(:,:) ) * zbeta(:,:) * umask(:,:,1) , &
-                  &                           ABS( v_ice(:,:) - zv_ice(:,:) ) * zbeta(:,:) * vmask(:,:,1) ) * zmsk15(:,:) )
+                  &                           ABS( v_ice(:,:) - zv_ice(:,:) ) * zbeta(:,:) * vmask(:,:,1) ) * aimsk15(:,:) )
             ELSE                 ! output: nn_nevp * ( u(t=nn_nevp) - u(t=nn_nevp-1) )
                CALL iom_put( 'uice_cvg', REAL( nn_nevp ) * MAX( ABS( u_ice(:,:) - zu_ice(:,:) ) * umask(:,:,1) , &
-                  &                                             ABS( v_ice(:,:) - zv_ice(:,:) ) * vmask(:,:,1) ) * zmsk15(:,:) )
+                  &                                             ABS( v_ice(:,:) - zv_ice(:,:) ) * vmask(:,:,1) ) * aimsk15(:,:) )
             ENDIF
          ENDIF
       ENDIF
       !
-      DEALLOCATE( zmsk00, zmsk15 )
-      !
    END SUBROUTINE ice_dyn_rhg_eap
 
 
-   SUBROUTINE rhg_cvg( kt, kiter, kitermax, pu, pv, pub, pvb )
+   SUBROUTINE rhg_cvg_eap( kt, kiter, kitermax, pu, pv, pub, pvb )
       !!----------------------------------------------------------------------
-      !!                    ***  ROUTINE rhg_cvg  ***
+      !!                    ***  ROUTINE rhg_cvg_eap  ***
       !!
       !! ** Purpose :   check convergence of oce rheology
@@ -1006,5 +1015,4 @@
       REAL(wp)          ::   zresm           ! local real
       CHARACTER(len=20) ::   clname
-      REAL(wp), DIMENSION(jpi,jpj) ::   zres           ! check convergence
       !!----------------------------------------------------------------------
 
@@ -1014,5 +1022,5 @@
          IF( lwp ) THEN
             WRITE(numout,*)
-            WRITE(numout,*) 'rhg_cvg : ice rheology convergence control'
+            WRITE(numout,*) 'rhg_cvg_eap : ice rheology convergence control'
             WRITE(numout,*) '~~~~~~~'
          ENDIF
@@ -1037,8 +1045,9 @@
       ELSE
          DO_2D( 1, 1, 1, 1 )
-            zres(ji,jj) = MAX( ABS( pu(ji,jj) - pub(ji,jj) ) * umask(ji,jj,1), &
-               &               ABS( pv(ji,jj) - pvb(ji,jj) ) * vmask(ji,jj,1) ) * zmsk15(ji,jj)
+            eap_res(ji,jj) = MAX( ABS( pu(ji,jj) - pub(ji,jj) ) * umask(ji,jj,1), &
+               &               ABS( pv(ji,jj) - pvb(ji,jj) ) * vmask(ji,jj,1) ) * aimsk15(ji,jj)
          END_2D
-         zresm = MAXVAL( zres )
+
+         zresm = MAXVAL( eap_res )
          CALL mpp_max( 'icedyn_rhg_evp', zresm )   ! max over the global domain
       ENDIF
@@ -1051,5 +1060,5 @@
       ENDIF
 
-   END SUBROUTINE rhg_cvg
+   END SUBROUTINE rhg_cvg_eap
 
 
@@ -1080,20 +1089,18 @@
       REAL(wp) ::   zsig11, zsig12, zsig22
       REAL(wp) ::   zsgprm11, zsgprm12, zsgprm22
-      REAL(wp) ::   zinvstressconviso
       REAL(wp) ::   zAngle_denom_gamma,  zAngle_denom_alpha
       REAL(wp) ::   zTany_1, zTany_2
-      REAL(wp) ::   zx, zy, zdx, zdy, zda, zkxw, kyw, kaw
+      REAL(wp) ::   zx, zy, zkxw, kyw, kaw
       REAL(wp) ::   zinvdx, zinvdy, zinvda
-      REAL(wp) ::   zdtemp1, zdtemp2, zatempprime, zinvsin
-
-      REAL(wp), PARAMETER ::   kfriction = 0.45_wp
-      !!---------------------------------------------------------------------
+      REAL(wp) ::   zdtemp1, zdtemp2, zatempprime
+
+      REAL(wp), PARAMETER ::   ppkfriction = 0.45_wp
       ! Factor to maintain the same stress as in EVP (see Section 3)
       ! Can be set to 1 otherwise
-!      zinvstressconviso = 1._wp/(1._wp+kfriction*kfriction)
-      zinvstressconviso = 1._wp
-
-      zinvsin = 1._wp/sin(2._wp*pphi) * zinvstressconviso
-      !now uses phi as set in higher code
+!     REAL(wp), PARAMETER ::   ppinvstressconviso = 1._wp/(1._wp+ppkfriction*ppkfriction)
+      REAL(wp), PARAMETER ::   ppinvstressconviso = 1._wp
+
+      ! next statement uses pphi set in main module (icedyn_rhg_eap)
+      REAL(wp), PARAMETER ::   ppinvsin = 1._wp/sin(2._wp*pphi) * ppinvstressconviso
 
       ! compute eigenvalues, eigenvectors and angles for structure tensor, strain
@@ -1175,10 +1182,7 @@
 
       ! 3) update anisotropic stress tensor
-      zdx   = rpi/real(nx_yield-1,kind=wp)
-      zdy   = rpi/real(ny_yield-1,kind=wp)
-      zda   = 0.5_wp/real(na_yield-1,kind=wp)
-      zinvdx = 1._wp/zdx
-      zinvdy = 1._wp/zdy
-      zinvda = 1._wp/zda
+      zinvdx = real(nx_yield-1,kind=wp)/rpi
+      zinvdy = real(ny_yield-1,kind=wp)/rpi
+      zinvda = 2._wp*real(na_yield-1,kind=wp)
 
       ! % need 8 coords and 8 weights
@@ -1258,7 +1262,7 @@
       ! Tsamados 2013)
 
-      zsig11  = pstrength*(zstemp11r + kfriction*zstemp11s) * zinvsin
-      zsig12  = pstrength*(zstemp12r + kfriction*zstemp12s) * zinvsin
-      zsig22  = pstrength*(zstemp22r + kfriction*zstemp22s) * zinvsin
+      zsig11  = pstrength*(zstemp11r + ppkfriction*zstemp11s) * ppinvsin
+      zsig12  = pstrength*(zstemp12r + ppkfriction*zstemp12s) * ppinvsin
+      zsig22  = pstrength*(zstemp22r + ppkfriction*zstemp22s) * ppinvsin
 
       ! Back - rotation of the stress from principal axes into general coordinates
@@ -1319,7 +1323,7 @@
       REAL (wp) ::   zQ11, zQ12, zQ11Q11, zQ11Q12, zQ12Q12
 
-!!$      REAL (wp), PARAMETER ::   kfrac = 0.0001_wp   ! rate of fracture formation
-      REAL (wp), PARAMETER ::   kfrac = 1.e-3_wp   ! rate of fracture formation
-      REAL (wp), PARAMETER ::   threshold = 0.3_wp  ! critical confinement ratio
+!!$   REAL (wp), PARAMETER ::   ppkfrac = 0.0001_wp   ! rate of fracture formation
+      REAL (wp), PARAMETER ::   ppkfrac = 1.e-3_wp    ! rate of fracture formation
+      REAL (wp), PARAMETER ::   ppthreshold = 0.3_wp  ! critical confinement ratio
       !!---------------------------------------------------------------
       !
@@ -1363,6 +1367,6 @@
       ! which leads to the loss of their shape, so we again model it through diffusion
       ELSEIF ((zsigma_1 >= 0.0_wp).AND.(zsigma_2 < 0.0_wp))  THEN
-         pmresult11 = - kfrac * (pa11 - zQ12Q12)
-         pmresult12 = - kfrac * (pa12 + zQ11Q12)
+         pmresult11 = - ppkfrac * (pa11 - zQ12Q12)
+         pmresult12 = - ppkfrac * (pa12 + zQ11Q12)
 
       ! Shear faulting
@@ -1370,7 +1374,7 @@
          pmresult11 = 0.0_wp
          pmresult12 = 0.0_wp
-      ELSEIF ((zsigma_1 <= 0.0_wp).AND.(zsigma_1/zsigma_2 <= threshold)) THEN
-         pmresult11 = - kfrac * (pa11 - zQ12Q12)
-         pmresult12 = - kfrac * (pa12 + zQ11Q12)
+      ELSEIF ((zsigma_1 <= 0.0_wp).AND.(zsigma_1/zsigma_2 <= ppthreshold)) THEN
+         pmresult11 = - ppkfrac * (pa11 - zQ12Q12)
+         pmresult12 = - ppkfrac * (pa12 + zQ11Q12)
 
       ! Horizontal spalling
@@ -1405,5 +1409,6 @@
       !!clem
       REAL(wp) ::   zw1, zw2, zfac, ztemp
-      REAL(wp) ::   idx, idy, idz
+      REAL(wp) ::   zidx, zidy, zidz
+      REAL(wp) ::   zsaak(6)                  ! temporary array
 
       REAL(wp), PARAMETER           ::   eps6 = 1.0e-6_wp
@@ -1522,33 +1527,36 @@
             zw2 = w2(ainit+ia*da)
             DO iz = 1, nz
-               idz = zinit+iz*dz
+               zidz = zinit+iz*dz
                ztemp = zw1 * EXP(-zw2*(zinit+iz*dz)*(zinit+iz*dz))
                DO iy = 1, ny_yield
-                  idy = yinit+iy*dy
+                  zidy = yinit+iy*dy
                   DO ix = 1, nx_yield
-                     idx = xinit+ix*dx
-                     s11r(ix,iy,ia) = s11r(ix,iy,ia) + ztemp * s11kr(idx,idy,idz)*zfac
-                     s12r(ix,iy,ia) = s12r(ix,iy,ia) + ztemp * s12kr(idx,idy,idz)*zfac
-                     s22r(ix,iy,ia) = s22r(ix,iy,ia) + ztemp * s22kr(idx,idy,idz)*zfac
-                     s11s(ix,iy,ia) = s11s(ix,iy,ia) + ztemp * s11ks(idx,idy,idz)*zfac
-                     s12s(ix,iy,ia) = s12s(ix,iy,ia) + ztemp * s12ks(idx,idy,idz)*zfac
-                     s22s(ix,iy,ia) = s22s(ix,iy,ia) + ztemp * s22ks(idx,idy,idz)*zfac
+                     zidx = xinit+ix*dx
+                     call all_skr_sks(zidx,zidy,zidz,zsaak)
+                     zsaak = ztemp*zsaak*zfac
+                     s11r(ix,iy,ia) = s11r(ix,iy,ia) + zsaak(1)
+                     s12r(ix,iy,ia) = s12r(ix,iy,ia) + zsaak(2)
+                     s22r(ix,iy,ia) = s22r(ix,iy,ia) + zsaak(3)
+                     s11s(ix,iy,ia) = s11s(ix,iy,ia) + zsaak(4)
+                     s12s(ix,iy,ia) = s12s(ix,iy,ia) + zsaak(5)
+                     s22s(ix,iy,ia) = s22s(ix,iy,ia) + zsaak(6)
                   END DO
                END DO
             END DO
          END DO
-
          zfac = 1._wp/sin(2._wp*pphi)
          ia = na_yield
          DO iy = 1, ny_yield
-            idy = yinit+iy*dy
+            zidy = yinit+iy*dy
             DO ix = 1, nx_yield
-               idx = xinit+ix*dx
-               s11r(ix,iy,ia) = 0.5_wp*s11kr(idx,idy,0._wp)*zfac
-               s12r(ix,iy,ia) = 0.5_wp*s12kr(idx,idy,0._wp)*zfac
-               s22r(ix,iy,ia) = 0.5_wp*s22kr(idx,idy,0._wp)*zfac
-               s11s(ix,iy,ia) = 0.5_wp*s11ks(idx,idy,0._wp)*zfac
-               s12s(ix,iy,ia) = 0.5_wp*s12ks(idx,idy,0._wp)*zfac
-               s22s(ix,iy,ia) = 0.5_wp*s22ks(idx,idy,0._wp)*zfac
+               zidx = xinit+ix*dx
+               call all_skr_sks(zidx,zidy,0._wp,zsaak)
+               zsaak = 0.5_wp*zsaak*zfac
+               s11r(ix,iy,ia) = zsaak(1)
+               s12r(ix,iy,ia) = zsaak(2)
+               s22r(ix,iy,ia) = zsaak(3)
+               s11s(ix,iy,ia) = zsaak(4)
+               s12s(ix,iy,ia) = zsaak(5)
+               s22s(ix,iy,ia) = zsaak(6)
             ENDDO
          ENDDO
@@ -1616,12 +1624,12 @@
    END FUNCTION w2
 
-   FUNCTION s11kr(px,py,pz)
-      !!-------------------------------------------------------------------
-      !! Function : s11kr
-      !!-------------------------------------------------------------------
+   SUBROUTINE all_skr_sks( px, py, pz, allsk )
       REAL(wp), INTENT(in   ) ::   px,py,pz
-
-      REAL(wp) ::   s11kr, zpih
-
+      REAL(wp), INTENT(out  ) ::   allsk(6)
+
+      REAL(wp) ::   zs12r0, zs21r0
+      REAL(wp) ::   zs12s0, zs21s0
+
+      REAL(wp) ::   zpih
       REAL(wp) ::   zn1t2i11, zn1t2i12, zn1t2i21, zn1t2i22
       REAL(wp) ::   zn2t1i11, zn2t1i12, zn2t1i21, zn2t1i22
@@ -1673,296 +1681,34 @@
       ENDIF
 
-      s11kr = (- zHen1t2 * zn1t2i11 - zHen2t1 * zn2t1i11)
-
-   END FUNCTION s11kr
-
-   FUNCTION s12kr(px,py,pz)
+      !!-------------------------------------------------------------------
+      !! Function : s11kr
+      !!-------------------------------------------------------------------
+      allsk(1) = (- zHen1t2 * zn1t2i11 - zHen2t1 * zn2t1i11)
       !!-------------------------------------------------------------------
       !! Function : s12kr
       !!-------------------------------------------------------------------
-      REAL(wp), INTENT(in   ) ::   px,py,pz
-
-      REAL(wp) ::   s12kr, zs12r0, zs21r0, zpih
-
-      REAL(wp) ::   zn1t2i11, zn1t2i12, zn1t2i21, zn1t2i22
-      REAL(wp) ::   zn2t1i11, zn2t1i12, zn2t1i21, zn2t1i22
-      REAL(wp) ::   zt1t2i11, zt1t2i12, zt1t2i21, zt1t2i22
-      REAL(wp) ::   zt2t1i11, zt2t1i12, zt2t1i21, zt2t1i22
-      REAL(wp) ::   zd11, zd12, zd22
-      REAL(wp) ::   zIIn1t2, zIIn2t1, zIIt1t2
-      REAL(wp) ::   zHen1t2, zHen2t1
-      !!-------------------------------------------------------------------
-      zpih = 0.5_wp*rpi
-
-      zn1t2i11 = cos(pz+zpih-pphi) * cos(pz+pphi)
-      zn1t2i12 = cos(pz+zpih-pphi) * sin(pz+pphi)
-      zn1t2i21 = sin(pz+zpih-pphi) * cos(pz+pphi)
-      zn1t2i22 = sin(pz+zpih-pphi) * sin(pz+pphi)
-      zn2t1i11 = cos(pz-zpih+pphi) * cos(pz-pphi)
-      zn2t1i12 = cos(pz-zpih+pphi) * sin(pz-pphi)
-      zn2t1i21 = sin(pz-zpih+pphi) * cos(pz-pphi)
-      zn2t1i22 = sin(pz-zpih+pphi) * sin(pz-pphi)
-      zt1t2i11 = cos(pz-pphi) * cos(pz+pphi)
-      zt1t2i12 = cos(pz-pphi) * sin(pz+pphi)
-      zt1t2i21 = sin(pz-pphi) * cos(pz+pphi)
-      zt1t2i22 = sin(pz-pphi) * sin(pz+pphi)
-      zt2t1i11 = cos(pz+pphi) * cos(pz-pphi)
-      zt2t1i12 = cos(pz+pphi) * sin(pz-pphi)
-      zt2t1i21 = sin(pz+pphi) * cos(pz-pphi)
-      zt2t1i22 = sin(pz+pphi) * sin(pz-pphi)
-      zd11 = cos(py)*cos(py)*(cos(px)+sin(px)*tan(py)*tan(py))
-      zd12 = cos(py)*cos(py)*tan(py)*(-cos(px)+sin(px))
-      zd22 = cos(py)*cos(py)*(sin(px)+cos(px)*tan(py)*tan(py))
-      zIIn1t2 = zn1t2i11 * zd11 + (zn1t2i12 + zn1t2i21) * zd12 + zn1t2i22 * zd22
-      zIIn2t1 = zn2t1i11 * zd11 + (zn2t1i12 + zn2t1i21) * zd12 + zn2t1i22 * zd22
-      zIIt1t2 = zt1t2i11 * zd11 + (zt1t2i12 + zt1t2i21) * zd12 + zt1t2i22 * zd22
-
-      IF (-zIIn1t2>=rsmall) THEN
-      zHen1t2 = 1._wp
-      ELSE
-      zHen1t2 = 0._wp
-      ENDIF
-
-      IF (-zIIn2t1>=rsmall) THEN
-      zHen2t1 = 1._wp
-      ELSE
-      zHen2t1 = 0._wp
-      ENDIF
-
       zs12r0 = (- zHen1t2 * zn1t2i12 - zHen2t1 * zn2t1i12)
       zs21r0 = (- zHen1t2 * zn1t2i21 - zHen2t1 * zn2t1i21)
-      s12kr=0.5_wp*(zs12r0+zs21r0)
-
-   END FUNCTION s12kr
-
-   FUNCTION s22kr(px,py,pz)
+      allsk(2)=0.5_wp*(zs12r0+zs21r0)
       !!-------------------------------------------------------------------
       !! Function : s22kr
       !!-------------------------------------------------------------------
-      REAL(wp), INTENT(in   ) ::   px,py,pz
-
-      REAL(wp) ::   s22kr, zpih
-
-      REAL(wp) ::   zn1t2i11, zn1t2i12, zn1t2i21, zn1t2i22
-      REAL(wp) ::   zn2t1i11, zn2t1i12, zn2t1i21, zn2t1i22
-      REAL(wp) ::   zt1t2i11, zt1t2i12, zt1t2i21, zt1t2i22
-      REAL(wp) ::   zt2t1i11, zt2t1i12, zt2t1i21, zt2t1i22
-      REAL(wp) ::   zd11, zd12, zd22
-      REAL(wp) ::   zIIn1t2, zIIn2t1, zIIt1t2
-      REAL(wp) ::   zHen1t2, zHen2t1
-      !!-------------------------------------------------------------------
-      zpih = 0.5_wp*rpi
-
-      zn1t2i11 = cos(pz+zpih-pphi) * cos(pz+pphi)
-      zn1t2i12 = cos(pz+zpih-pphi) * sin(pz+pphi)
-      zn1t2i21 = sin(pz+zpih-pphi) * cos(pz+pphi)
-      zn1t2i22 = sin(pz+zpih-pphi) * sin(pz+pphi)
-      zn2t1i11 = cos(pz-zpih+pphi) * cos(pz-pphi)
-      zn2t1i12 = cos(pz-zpih+pphi) * sin(pz-pphi)
-      zn2t1i21 = sin(pz-zpih+pphi) * cos(pz-pphi)
-      zn2t1i22 = sin(pz-zpih+pphi) * sin(pz-pphi)
-      zt1t2i11 = cos(pz-pphi) * cos(pz+pphi)
-      zt1t2i12 = cos(pz-pphi) * sin(pz+pphi)
-      zt1t2i21 = sin(pz-pphi) * cos(pz+pphi)
-      zt1t2i22 = sin(pz-pphi) * sin(pz+pphi)
-      zt2t1i11 = cos(pz+pphi) * cos(pz-pphi)
-      zt2t1i12 = cos(pz+pphi) * sin(pz-pphi)
-      zt2t1i21 = sin(pz+pphi) * cos(pz-pphi)
-      zt2t1i22 = sin(pz+pphi) * sin(pz-pphi)
-      zd11 = cos(py)*cos(py)*(cos(px)+sin(px)*tan(py)*tan(py))
-      zd12 = cos(py)*cos(py)*tan(py)*(-cos(px)+sin(px))
-      zd22 = cos(py)*cos(py)*(sin(px)+cos(px)*tan(py)*tan(py))
-      zIIn1t2 = zn1t2i11 * zd11 + (zn1t2i12 + zn1t2i21) * zd12 + zn1t2i22 * zd22
-      zIIn2t1 = zn2t1i11 * zd11 + (zn2t1i12 + zn2t1i21) * zd12 + zn2t1i22 * zd22
-      zIIt1t2 = zt1t2i11 * zd11 + (zt1t2i12 + zt1t2i21) * zd12 + zt1t2i22 * zd22
-
-      IF (-zIIn1t2>=rsmall) THEN
-      zHen1t2 = 1._wp
-      ELSE
-      zHen1t2 = 0._wp
-      ENDIF
-
-      IF (-zIIn2t1>=rsmall) THEN
-      zHen2t1 = 1._wp
-      ELSE
-      zHen2t1 = 0._wp
-      ENDIF
-
-      s22kr = (- zHen1t2 * zn1t2i22 - zHen2t1 * zn2t1i22)
-
-   END FUNCTION s22kr
-
-   FUNCTION s11ks(px,py,pz)
+      allsk(3) = (- zHen1t2 * zn1t2i22 - zHen2t1 * zn2t1i22)
       !!-------------------------------------------------------------------
       !! Function : s11ks
       !!-------------------------------------------------------------------
-      REAL(wp), INTENT(in   ) ::   px,py,pz
-
-      REAL(wp) ::   s11ks, zpih
-
-      REAL(wp) ::   zn1t2i11, zn1t2i12, zn1t2i21, zn1t2i22
-      REAL(wp) ::   zn2t1i11, zn2t1i12, zn2t1i21, zn2t1i22
-      REAL(wp) ::   zt1t2i11, zt1t2i12, zt1t2i21, zt1t2i22
-      REAL(wp) ::   zt2t1i11, zt2t1i12, zt2t1i21, zt2t1i22
-      REAL(wp) ::   zd11, zd12, zd22
-      REAL(wp) ::   zIIn1t2, zIIn2t1, zIIt1t2
-      REAL(wp) ::   zHen1t2, zHen2t1
-      !!-------------------------------------------------------------------
-      zpih = 0.5_wp*rpi
-
-      zn1t2i11 = cos(pz+zpih-pphi) * cos(pz+pphi)
-      zn1t2i12 = cos(pz+zpih-pphi) * sin(pz+pphi)
-      zn1t2i21 = sin(pz+zpih-pphi) * cos(pz+pphi)
-      zn1t2i22 = sin(pz+zpih-pphi) * sin(pz+pphi)
-      zn2t1i11 = cos(pz-zpih+pphi) * cos(pz-pphi)
-      zn2t1i12 = cos(pz-zpih+pphi) * sin(pz-pphi)
-      zn2t1i21 = sin(pz-zpih+pphi) * cos(pz-pphi)
-      zn2t1i22 = sin(pz-zpih+pphi) * sin(pz-pphi)
-      zt1t2i11 = cos(pz-pphi) * cos(pz+pphi)
-      zt1t2i12 = cos(pz-pphi) * sin(pz+pphi)
-      zt1t2i21 = sin(pz-pphi) * cos(pz+pphi)
-      zt1t2i22 = sin(pz-pphi) * sin(pz+pphi)
-      zt2t1i11 = cos(pz+pphi) * cos(pz-pphi)
-      zt2t1i12 = cos(pz+pphi) * sin(pz-pphi)
-      zt2t1i21 = sin(pz+pphi) * cos(pz-pphi)
-      zt2t1i22 = sin(pz+pphi) * sin(pz-pphi)
-      zd11 = cos(py)*cos(py)*(cos(px)+sin(px)*tan(py)*tan(py))
-      zd12 = cos(py)*cos(py)*tan(py)*(-cos(px)+sin(px))
-      zd22 = cos(py)*cos(py)*(sin(px)+cos(px)*tan(py)*tan(py))
-      zIIn1t2 = zn1t2i11 * zd11 + (zn1t2i12 + zn1t2i21) * zd12 + zn1t2i22 * zd22
-      zIIn2t1 = zn2t1i11 * zd11 + (zn2t1i12 + zn2t1i21) * zd12 + zn2t1i22 * zd22
-      zIIt1t2 = zt1t2i11 * zd11 + (zt1t2i12 + zt1t2i21) * zd12 + zt1t2i22 * zd22
-
-      IF (-zIIn1t2>=rsmall) THEN
-      zHen1t2 = 1._wp
-      ELSE
-      zHen1t2 = 0._wp
-      ENDIF
-
-      IF (-zIIn2t1>=rsmall) THEN
-      zHen2t1 = 1._wp
-      ELSE
-      zHen2t1 = 0._wp
-      ENDIF
-
-      s11ks = sign(1._wp,zIIt1t2+rsmall)*(zHen1t2 * zt1t2i11 + zHen2t1 * zt2t1i11)
-
-   END FUNCTION s11ks
-
-   FUNCTION s12ks(px,py,pz)
+
+      allsk(4) = sign(1._wp,zIIt1t2+rsmall)*(zHen1t2 * zt1t2i11 + zHen2t1 * zt2t1i11)
       !!-------------------------------------------------------------------
       !! Function : s12ks
       !!-------------------------------------------------------------------
-      REAL(wp), INTENT(in   ) ::   px,py,pz
-
-      REAL(wp) ::   s12ks, zs12s0, zs21s0, zpih
-
-      REAL(wp) ::   zn1t2i11, zn1t2i12, zn1t2i21, zn1t2i22
-      REAL(wp) ::   zn2t1i11, zn2t1i12, zn2t1i21, zn2t1i22
-      REAL(wp) ::   zt1t2i11, zt1t2i12, zt1t2i21, zt1t2i22
-      REAL(wp) ::   zt2t1i11, zt2t1i12, zt2t1i21, zt2t1i22
-      REAL(wp) ::   zd11, zd12, zd22
-      REAL(wp) ::   zIIn1t2, zIIn2t1, zIIt1t2
-      REAL(wp) ::   zHen1t2, zHen2t1
-      !!-------------------------------------------------------------------
-      zpih = 0.5_wp*rpi
-
-      zn1t2i11 = cos(pz+zpih-pphi) * cos(pz+pphi)
-      zn1t2i12 = cos(pz+zpih-pphi) * sin(pz+pphi)
-      zn1t2i21 = sin(pz+zpih-pphi) * cos(pz+pphi)
-      zn1t2i22 = sin(pz+zpih-pphi) * sin(pz+pphi)
-      zn2t1i11 = cos(pz-zpih+pphi) * cos(pz-pphi)
-      zn2t1i12 = cos(pz-zpih+pphi) * sin(pz-pphi)
-      zn2t1i21 = sin(pz-zpih+pphi) * cos(pz-pphi)
-      zn2t1i22 = sin(pz-zpih+pphi) * sin(pz-pphi)
-      zt1t2i11 = cos(pz-pphi) * cos(pz+pphi)
-      zt1t2i12 = cos(pz-pphi) * sin(pz+pphi)
-      zt1t2i21 = sin(pz-pphi) * cos(pz+pphi)
-      zt1t2i22 = sin(pz-pphi) * sin(pz+pphi)
-      zt2t1i11 = cos(pz+pphi) * cos(pz-pphi)
-      zt2t1i12 = cos(pz+pphi) * sin(pz-pphi)
-      zt2t1i21 = sin(pz+pphi) * cos(pz-pphi)
-      zt2t1i22 = sin(pz+pphi) * sin(pz-pphi)
-      zd11 = cos(py)*cos(py)*(cos(px)+sin(px)*tan(py)*tan(py))
-      zd12 = cos(py)*cos(py)*tan(py)*(-cos(px)+sin(px))
-      zd22 = cos(py)*cos(py)*(sin(px)+cos(px)*tan(py)*tan(py))
-      zIIn1t2 = zn1t2i11 * zd11 + (zn1t2i12 + zn1t2i21) * zd12 + zn1t2i22 * zd22
-      zIIn2t1 = zn2t1i11 * zd11 + (zn2t1i12 + zn2t1i21) * zd12 + zn2t1i22 * zd22
-      zIIt1t2 = zt1t2i11 * zd11 + (zt1t2i12 + zt1t2i21) * zd12 + zt1t2i22 * zd22
-
-      IF (-zIIn1t2>=rsmall) THEN
-      zHen1t2 = 1._wp
-      ELSE
-      zHen1t2 = 0._wp
-      ENDIF
-
-      IF (-zIIn2t1>=rsmall) THEN
-      zHen2t1 = 1._wp
-      ELSE
-      zHen2t1 = 0._wp
-      ENDIF
-
       zs12s0 = sign(1._wp,zIIt1t2+rsmall)*(zHen1t2 * zt1t2i12 + zHen2t1 * zt2t1i12)
       zs21s0 = sign(1._wp,zIIt1t2+rsmall)*(zHen1t2 * zt1t2i21 + zHen2t1 * zt2t1i21)
-      s12ks=0.5_wp*(zs12s0+zs21s0)
-
-   END FUNCTION s12ks
-
-   FUNCTION s22ks(px,py,pz)
+      allsk(5)=0.5_wp*(zs12s0+zs21s0)
       !!-------------------------------------------------------------------
       !! Function : s22ks
       !!-------------------------------------------------------------------
-      REAL(wp), INTENT(in   ) ::   px,py,pz
-
-      REAL(wp) ::   s22ks, zpih
-
-      REAL(wp) ::   zn1t2i11, zn1t2i12, zn1t2i21, zn1t2i22
-      REAL(wp) ::   zn2t1i11, zn2t1i12, zn2t1i21, zn2t1i22
-      REAL(wp) ::   zt1t2i11, zt1t2i12, zt1t2i21, zt1t2i22
-      REAL(wp) ::   zt2t1i11, zt2t1i12, zt2t1i21, zt2t1i22
-      REAL(wp) ::   zd11, zd12, zd22
-      REAL(wp) ::   zIIn1t2, zIIn2t1, zIIt1t2
-      REAL(wp) ::   zHen1t2, zHen2t1
-      !!-------------------------------------------------------------------
-      zpih = 0.5_wp*rpi
-
-      zn1t2i11 = cos(pz+zpih-pphi) * cos(pz+pphi)
-      zn1t2i12 = cos(pz+zpih-pphi) * sin(pz+pphi)
-      zn1t2i21 = sin(pz+zpih-pphi) * cos(pz+pphi)
-      zn1t2i22 = sin(pz+zpih-pphi) * sin(pz+pphi)
-      zn2t1i11 = cos(pz-zpih+pphi) * cos(pz-pphi)
-      zn2t1i12 = cos(pz-zpih+pphi) * sin(pz-pphi)
-      zn2t1i21 = sin(pz-zpih+pphi) * cos(pz-pphi)
-      zn2t1i22 = sin(pz-zpih+pphi) * sin(pz-pphi)
-      zt1t2i11 = cos(pz-pphi) * cos(pz+pphi)
-      zt1t2i12 = cos(pz-pphi) * sin(pz+pphi)
-      zt1t2i21 = sin(pz-pphi) * cos(pz+pphi)
-      zt1t2i22 = sin(pz-pphi) * sin(pz+pphi)
-      zt2t1i11 = cos(pz+pphi) * cos(pz-pphi)
-      zt2t1i12 = cos(pz+pphi) * sin(pz-pphi)
-      zt2t1i21 = sin(pz+pphi) * cos(pz-pphi)
-      zt2t1i22 = sin(pz+pphi) * sin(pz-pphi)
-      zd11 = cos(py)*cos(py)*(cos(px)+sin(px)*tan(py)*tan(py))
-      zd12 = cos(py)*cos(py)*tan(py)*(-cos(px)+sin(px))
-      zd22 = cos(py)*cos(py)*(sin(px)+cos(px)*tan(py)*tan(py))
-      zIIn1t2 = zn1t2i11 * zd11 + (zn1t2i12 + zn1t2i21) * zd12 + zn1t2i22 * zd22
-      zIIn2t1 = zn2t1i11 * zd11 + (zn2t1i12 + zn2t1i21) * zd12 + zn2t1i22 * zd22
-      zIIt1t2 = zt1t2i11 * zd11 + (zt1t2i12 + zt1t2i21) * zd12 + zt1t2i22 * zd22
-
-      IF (-zIIn1t2>=rsmall) THEN
-      zHen1t2 = 1._wp
-      ELSE
-      zHen1t2 = 0._wp
-      ENDIF
-
-      IF (-zIIn2t1>=rsmall) THEN
-      zHen2t1 = 1._wp
-      ELSE
-      zHen2t1 = 0._wp
-      ENDIF
-
-      s22ks = sign(1._wp,zIIt1t2+rsmall)*(zHen1t2 * zt1t2i22 + zHen2t1 * zt2t1i22)
-
-   END FUNCTION s22ks
+      allsk(6) = sign(1._wp,zIIt1t2+rsmall)*(zHen1t2 * zt1t2i22 + zHen2t1 * zt2t1i22)
+   END SUBROUTINE all_skr_sks
 
 #else
